/*
Mammut parser generator
Copyright (C) 2005 Lumai HB - http://www.lumai.se
This source code is based on Bison++ by Alain Coetmeur.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  
02110-1301, USA
*/


#include <stdio.h>
#include "system.h"
#include "files.h"
#include "new.h"
#include "gram.h"

#include <string>
#include <fstream>
#include <stdexcept>

using namespace std;

ifstream finput;

std::stringstream faction;
std::stringstream ftable;

string infile;
string output_file;	// File name specified with -o for the output file
string configuration_file;
string file_prefix;

// Input/output skeleton files
string output_template;

void done(int);

extern bool verboseflag;
extern int definesflag;

void openfiles()
{
	if(infile.empty())
		throw std::runtime_error("No input file specified (try --help)");

	finput.open(infile.c_str());
	if (!finput.is_open())
		throw std::runtime_error("Cannot open input file '" + infile + '\'');
}

// Close all files, Update final .h file with real "#line xxx" directives
// adds inclusion guards
void done(int exitcode)
{
	exit(exitcode);
}
