/*
Mammut parser generator
Copyright (C) 2005 Lumai HB - http://www.lumai.se
This source code is based on Bison++ by Alain Coetmeur.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  
02110-1301, USA
*/


#ifndef FILES_H
#define FILES_H

/* File names and variables */
#include <string>
#include <sstream>
#include <fstream>

// Name used when expanding parsernames in template-files
extern std::string parser_name; 

extern std::ifstream finput;   /* read grammar specifications */

extern std::stringstream faction;
extern std::stringstream ftable;

extern std::string infile;
extern std::string output_file;	// File name specified with -o for the output file
extern std::string configuration_file;
extern std::string file_prefix;
extern std::string output_template;


#endif // FILES_H
