/*
Mammut parser generator
Copyright (C) 2005 Lumai HB - http://www.lumai.se
This source code is based on Bison++ by Alain Coetmeur.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  
02110-1301, USA
*/


/* Token type definitions for bison's input reader */

#define	ENDFILE		0
#define	IDENTIFIER	1
#define	COMMA		2
#define COLON		3
#define	SEMICOLON	4
#define	BAR		5
#define LEFT_CURLY	6
#define TWO_PERCENTS	7
#define PERCENT_LEFT_CURLY	8
#define	TOKEN		9
#define	NTERM		10
#define	TYPE	       12
#define	UNION	       13
#define START	       14
#define LEFT	       15
#define RIGHT	       16
#define NONASSOC       17
#define PREC	       18
#define TYPENAME       21
#define NUMBER	       22
#define EXPECT	       23

#define PERCENT_LEFT_CURLY_HEADER	       24
#define PARSER_NAME	       25
#define DEFINE_SYM	       26

#define	ILLEGAL	       27

#define	MAXTOKEN	1024
